%load data
inputs = cancerInputs;
targets = cancerTargets;
%data transformation
ava=[4.442166911,3.150805271,3.21522694,2.830161054,3.234260615,2.140819964,3.445095168,2.869692533,1.603221083];
ava=ava/10;
for i=1:9
   for j=1:699
      if inputs(i,j) > ava(i)
         inputs(i,j) = (inputs(i,j)-ava(i))/(1-ava(i));
      else 
         inputs(i,j) = (inputs(i,j)-ava(i))/ava(i);
      end
   end
end

for i=1:2
  for j=1:699
     if targets(i,j)==0
        targets(i,j)=-1;
     end
  end
end

%set up a neural network
net = feedforwardnet();
net.layers{1}.size=23;
net.inputs{1}.size=9;
net.layers{2}.size=2;
net.layers{1}.transferFcn = 'tansig';
net.layers{2}.transferFcn = 'tansig';

%copy weights and thresholds from a CILP neural network
net.IW{1,1} = [0, 19.0348, 19.0348, 19.0348, 19.0348, 19.0348, 19.0348, 19.0348, 0, 0, 0, 0, 0, 0, 0, 0, -19.0348, -19.0348, -19.0348, -19.0348, -19.0348, -19.0348, -19.0348;
 0, 19.0348, 0, 0, 0, 0, 0, 0, 19.0348, 19.0348, 19.0348, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0;
 0, 0, 19.0348, 0, 0, 0, 0, 0, 0, 0, 0, 19.0348, 19.0348, 19.0348, 0, 0, -19.0348, 0, 0, 0, 0, 0, 0;
 0, 0, 0, 19.0348, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19.0348, 0, 0, -19.0348, 0, 0, 0, 0, 0;
 0, 0, 0, 0, 19.0348, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 19.0348, 0, 0, -19.0348, 0, 0, 0, 0;
 19.0348, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -19.0348, 0, 0, 0;
 0, 0, 0, 0, 0, 19.0348, 0, 0, 19.0348, 0, 0, 19.0348, 0, 0, 0, 0, 0, 0, 0, 0, -19.0348, 0, 0;
 0, 0, 0, 0, 0, 0, 19.0348, 0, 0, 19.0348, 0, 0, 19.0348, 0, 19.0348, 0, 0, 0, 0, 0, 0, -19.0348, 0;
 0, 0, 0, 0, 0, 0, 0, 19.0348, 0, 0, 19.0348, 0, 0, 19.0348, 0, 19.0348, 0, 0, 0, 0, 0, 0, -19.0348]';

net.b{1}=[0, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991, 17.9991]';
net.b{1}=-1*net.b{1};

net.LW{2,1}= [0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 0, 19.0348;
 19.0348, 0;
 19.0348, 0;
 19.0348, 0;
 19.0348, 0;
 19.0348, 0;
 19.0348, 0;
 19.0348, 0]';
net.b{2}=[-107.9948, -269.9869]';
net.b{2}=-1*net.b{2};


% Setup Division of Data for Training, Validation, Testing
% For a list of all data division functions type: help nndivide
net.divideFcn = 'dividerand';  % Divide data randomly
net.divideMode = 'sample';  % Divide up every sample
net.divideParam.trainRatio = 70/100;
net.divideParam.valRatio = 15/100;
net.divideParam.testRatio = 15/100;

% For help on training function 'trainlm' type: help trainlm
% For a list of all training functions type: help nntrain
net.trainFcn = 'trainscg';  % Scaled conjugate gradient backpropagation

% Choose a Performance Function
% For a list of all performance functions type: help nnperformance
net.performFcn = 'mse';  % Mean squared error

% Choose Plot Functions
% For a list of all plot functions type: help nnplot
net.plotFcns = {'plotperform','plottrainstate','ploterrhist', ...
  'plotregression', 'plotfit'};

%set up the performance goal
%net.trainParam.goal=0.000001;

% Train the Network
[net,tr] = train(net,inputs,targets);

% Test the Network
outputs = net(inputs);
errors = gsubtract(targets,outputs);
performance = perform(net,targets,outputs)

% Recalculate Training, Validation and Test Performance
trainTargets = targets .* tr.trainMask{1};
valTargets = targets  .* tr.valMask{1};
testTargets = targets  .* tr.testMask{1};
trainPerformance = perform(net,trainTargets,outputs)
valPerformance = perform(net,valTargets,outputs)
testPerformance = perform(net,testTargets,outputs)

% View the Network
view(net)

% Plots
% Uncomment these lines to enable various plots.
figure, plotperform(tr)
figure, plottrainstate(tr)
figure, plotconfusion(targets,outputs)
figure, ploterrhist(errors)

