% Solve a Pattern Recognition Problem with a Neural Network
% Script generated by NPRTOOL
% Created Fri Apr 15 21:45:01 BST 2011
%
% This script assumes these variables are defined:
%
%   cancerInputs - input data.
%   cancerTargets - target data.

inputs = cancerInputs;
targets = cancerTargets;

% Create a Pattern Recognition Network
hiddenLayerSize = 10;
net = patternnet(hiddenLayerSize);

% Choose Input and Output Pre/Post-Processing Functions
% For a list of all processing functions type: help nnprocess
net.inputs{1}.processFcns = {'removeconstantrows','mapminmax'};
net.outputs{2}.processFcns = {'removeconstantrows','mapminmax'};


% Setup Division of Data for Training, Validation, Testing
% For a list of all data division functions type: help nndivide
net.divideFcn = 'dividerand';  % Divide data randomly
net.divideMode = 'sample';  % Divide up every sample
net.divideParam.trainRatio = 70/100;
net.divideParam.valRatio = 15/100;
net.divideParam.testRatio = 15/100;

% For help on training function 'trainlm' type: help trainlm
% For a list of all training functions type: help nntrain
net.trainFcn = 'trainscg';  % 

% Choose a Performance Function
% For a list of all performance functions type: help nnperformance
net.performFcn = 'mse';  % Mean squared error

% Choose Plot Functions
% For a list of all plot functions type: help nnplot
net.plotFcns = {'plotperform','plottrainstate','ploterrhist', ...
  'plotregression', 'plotfit'};


% Train the Network
[net,tr] = train(net,inputs,targets);

% Test the Network
outputs = net(inputs);
errors = gsubtract(targets,outputs);
performance = perform(net,targets,outputs)

% Recalculate Training, Validation and Test Performance
trainTargets = targets .* tr.trainMask{1};
valTargets = targets  .* tr.valMask{1};
testTargets = targets  .* tr.testMask{1};
trainPerformance = perform(net,trainTargets,outputs)
valPerformance = perform(net,valTargets,outputs)
testPerformance = perform(net,testTargets,outputs)

% View the Network
view(net)

% Plots
% Uncomment these lines to enable various plots.
%figure, plotperform(tr)
%figure, plottrainstate(tr)
%figure, plotconfusion(targets,outputs)
%figure, ploterrhist(errors)

%a pedagogical approach for coarse knowlege
Z=ones(9,1);
for i=1:9 
    A=Z;
    A(i,1)=0.1;
    str = sprintf('%d',i);
    disp(str);
    net(A)   
end

Z=ones(9,1);
for i=1:9 
    A=Z;
    A(i,1)=0.1;
    for j=i+1:9     
        A(j,1)=0.1;    
        str = sprintf('%d  %d',i,j);
        disp(str);
        net(A)
    end
end

Z=ones(9,1);
for h=1:7
    A=Z;
    A(h,1)=0.1;
for i=h+1:8
    A(i,1)=0.1;
    for j=i+1:9 
        A(j,1)=0.1;      
           str = sprintf('%d  %d  %d',h,i,j);
           disp(str);         
          net(A)
     end
end
end

Z=ones(9,1);
for f=1:6
   A=Z;
   A(f,1)=0.1;
for h=f+1:7
   A(h,1)=0.1;
for i=h+1:8
   A(i,1)=0.1;
    for j=i+1:9 
        A(j,1)=0.1;      
           str = sprintf('%d  %d  %d  %d',f,h,i,j);
           disp(str);         
          net(A)
     end
end
end
end

Z=ones(9,1);
for e=1:3 
 A=Z;
 A(e,1)=0.1;
for f=e+1:4
 A(f,1)=0.1;
for g=f+1:5
 A(g,1)=0.1;
for h=g+1:6
 A(h,1)=0.1;
for i=h+1:7
    A(i,1)=0.1;
    for j=i+1:8
        A(j,1)=0.1;
        for k=j+1:9
           A(k,1)=0.1;
           str = sprintf('%d  %d  %d  %d  %d  %d  %d',e, f, g,h, i,j,k);
           disp(str);         
          net(A)
       end
    end
end
end
end
end
end

%
Z=ones(9,1);
Z=Z*0.1;    
for j=1:9 
   A=Z;
   A(j,1)=1;
   str = sprintf('%d',j);
   disp(str);
   net(A)
end


Z=ones(9,1);
Z=Z*0.1;
for i=1:8
    A=Z;
    A(i,1)=1;
    for j=i+1:9 
        A(j,1)=1;
        str = sprintf('%d  %d',i,j);
        disp(str);
        net(A)
    end
end



Z=ones(9,1);
Z=Z*0.1;
for h=1:7
A=Z;
A(h,1)=1;
for i=h+1:8
    A(i,1)=1;
    for j=i+1:9 
        A(j,1)=1;
        str = sprintf('%d  %d  %d',h,i,j);
        disp(str);
        net(A)
    end
end
end

Z=ones(9,1);
Z=Z*0.1;
for g=1:6
A=Z;
A(g,1)=1;
for h=g+1:7
A(h,1)=1;
for i=h+1:8
    A(i,1)=1;
    for j=i+1:9 
        A(j,1)=1;
        str = sprintf('%d  %d  %d  %d',g,h,i,j);
        disp(str);
        net(A)
    end
end
end
end

Z=Z*0.1;
for f=1:5
  A=Z;
  A(f,1)=1;
for g=1+f:6
  A(g,1)=1;
for h=g+1:7
  A(h,1)=1;
for i=h+1:8
    A(i,1)=1;
    for j=i+1:9 
        str = sprintf('%d  %d  %d  %d  %d',f, g,h,i,j);
        disp(str);
        A(j,1)=1;
        net(A)
    end
end
end
end
end
